﻿using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Problems.Robocode {
  [StorableClass]
  public sealed class Solution : NamedItem {
    //private int moves;
    //[Storable]
    //public int Moves
    //{
    //    get { return moves; }
    //    private set { this.moves = value; }
    //}
    //private int shots;
    //[Storable]
    //public int Shots
    //{
    //    get { return shots; }
    //    private set { this.shots = value; }
    //}
    [Storable]
    public ISymbolicExpressionTree Tree { get; set; }

    [Storable]
    public string Path { get; set; }

    [StorableConstructor]
    private Solution(bool deserializing) : base(deserializing) { }
    private Solution(Solution original, Cloner cloner)
      : base(original, cloner) {

      Tree = cloner.Clone(original.Tree);
      Path = original.Path;
    }

    public Solution(ISymbolicExpressionTree tree, string path)// int moves, int shots)
      : base("Solution", "A tank program.") {
      this.Tree = tree;
      this.Path = path;
      //this.moves = moves;
      //this.shots = shots;
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new Solution(this, cloner);
    }
  }
}